package de.uks.plm.ftglb.incremental.utsgOneQueue;

import x10.compiler.Inline;

import de.uks.plm.ftglb.incremental.TaskBag;

public final class Bag implements TaskBag
{
    public var hash:Rail[TreeNode];

    @Inline public def this(val size:Long) : Bag
    {
        hash = new Rail[TreeNode](size);
    }

    @Inline public def merge(val that:TaskBag) : void
    {
         this.merge(that as Bag);
    }

    @Inline public def merge(val that:Bag) : void
    {
        val newHash:Rail[TreeNode]
            = new Rail[TreeNode] (this.size() + that.size());

        Rail.copy(this.hash, 0, newHash, 0, this.size());
        Rail.copy(that.hash, 0, newHash, this.size(), that.size());
        this.hash = newHash;
    }

    @Inline public def size() : Long
    {
        return (this.hash.size);
    }
}