package de.uks.plm.utils;

import x10.compiler.Inline;

public class AssertPrinter
{
    @Inline public static final def print(val obj:Any) : void
    {
        assert(AssertPrinter.assertPrint(obj.toString()));
    }

    @Inline public static final def print(val text:String) : void
    {
        assert(AssertPrinter.assertPrint(text));
    }

    @Inline private static final def assertPrint(val text:String) : Boolean
    {
         Console.OUT.print(text);
         return (true);
    }

    @Inline public static final def println(val obj:Any) : void
    {
        assert(AssertPrinter.assertPrintln(obj.toString()));
    }

    @Inline public static final def println(val text:String) : void
    {
        assert(AssertPrinter.assertPrintln(text));
    }

    @Inline private static final def assertPrintln(val text:String) : Boolean
    {
        Console.OUT.println(text);
        return (true);
    }
}